Attribute VB_Name = "basRES"
Option Explicit

' Temporre Dateinamen
Public Declare Function GetTempFileName Lib "kernel32" _
  Alias "GetTempFileNameA" (ByVal lpszPath As String, _
  ByVal lpPrefixString As String, ByVal wUnique As Long, _
  ByVal lpTempFileName As String) As Long
  
Public Declare Function GetTempPath Lib "kernel32.dll" _
  Alias "GetTempPathA" (ByVal nBufferLength As Long, _
  ByVal lpBuffer As String) As Long
  
' RTF-Daten aus der Ressourcen-Datei
Public Function LoadRTFFromRes(ByVal ResID As Long, Optional Abschnitt As String = "RTF") As String
  Dim bRTF() As Byte
  Dim strRTF As String

  ' Ressource lesen: Rckgabe Byte-Array
  bRTF = LoadResData(ResID, Abschnitt)

  ' Umwandeln des ByteArrays in einen String
  LoadRTFFromRes = StrConv(bRTF(), vbUnicode)
End Function

' Byte-Array temporr speichern
' hierfr wird im TEMP-verzeichnis eine TMP-Datei
' erzeugt, deren Pfad und Namen von der Funktion
' zurckgegeben wird
Public Function resSaveDataTemp(ByRef bData() As Byte, Optional Type1 As String) As String
  Dim F As Integer
  Dim sTempPath As String
  Dim sTempFile As String
  Dim lngResult As Long
  
  ' Temporres Verzeichnis ermitteln
  sTempPath = Space$(256)
  lngResult = GetTempPath(Len(sTempPath), sTempPath)
  sTempPath = Left$(sTempPath, lngResult)
  
  ' Temporren Dateinamen ermitteln
  sTempFile = Space$(256)
  Call GetTempFileName(sTempPath, "~RES", 0&, sTempFile)
  sTempFile = Left$(sTempFile, InStr(sTempFile, Chr$(0)) - 1)
  If UCase(Type1) = "MID" Then
    Dim nPos As Integer
    nPos = InstrRev(sTempFile, ".")
    sTempFile = Left$(sTempFile, nPos - 1) & "mid"
  End If
  ' Byte-Array in temporre Datei speichern
  F = FreeFile
  Open sTempFile For Binary As #F
  Put #F, , bData()
  Close #F

  ' Pfad+Namen der TEMP-Datei zurckgeben
  resSaveDataTemp = sTempFile
End Function
